"use strict";

var _ssh = require("./ssh");

var _ssh2 = _interopRequireDefault(_ssh);

var _shelljs = require("shelljs");

var _shelljs2 = _interopRequireDefault(_shelljs);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var consumerProjectRoot = _path2.default.resolve("./"); // evanston-avenue, for instance
require('dotenv').config({ path: _path2.default.join(consumerProjectRoot, './.env') });

var ssh = new _ssh2.default();
ssh.connect().then(ssh.cloudpackage.bind(ssh)) /* package everything via ssh in the cloud */
.then(ssh.download.bind(ssh)) /* download .zip package */
.then(function () {

    /* extract package from cloud */
    _shelljs2.default.exec("unzip -o " + _path2.default.join(consumerProjectRoot, './deploy/pull.zip') + " -d " + _path2.default.join(consumerProjectRoot, './www'));

    /* push database to localhost */
    /* mysql -u wordpress -pdaytonflyers webfocused < pull.sql */
    _shelljs2.default.exec("mysql -u wordpress -p" + process.env.MYSQL_LOCAL_PWD + " " + process.env.MYSQL_LOCAL_DBNAME + " < " + _path2.default.join(consumerProjectRoot, './deploy/pull.sql'));

    /* replace cloud host with localhost */
    var dbcmd = "";
    dbcmd += "UPDATE wp_options SET option_value = replace(option_value, '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "') WHERE option_name = 'home' OR option_name = 'siteurl';";
    dbcmd += "UPDATE wp_posts SET guid = replace(guid, '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";
    dbcmd += "UPDATE wp_posts SET post_content = replace(post_content, '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";
    dbcmd += "UPDATE wp_postmeta SET meta_value = replace(meta_value,'" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";

    var entirecmd = "mysql -u wordpress -p" + process.env.MYSQL_LOCAL_PWD + " -D" + process.env.MYSQL_LOCAL_DBNAME + " -t -e \"" + dbcmd + "\"";
    console.log(entirecmd);
    _shelljs2.default.exec(entirecmd);
    console.log("Updated.");
}).then(function () {
    process.exit(0);
});