"use strict";

var _shelljs = require("shelljs");

var _shelljs2 = _interopRequireDefault(_shelljs);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _questions = require("questions");

var _questions2 = _interopRequireDefault(_questions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var consumerProjectRoot = _path2.default.resolve("./"); // evanston-avenue, for instance
require('dotenv').config({ path: _path2.default.join(consumerProjectRoot, './.env') });

_questions2.default.askOne({ info: 'Use content from:\n1: localhost from `yarn run pull-local` (pull.sql)\n2: Remote host from last push (push.sql)\n' }, function (result) {
    if (result == "1") {
        /* push database to localhost */
        /* mysql -u wordpress -pdaytonflyers webfocused < pull.sql */
        _shelljs2.default.exec("mysql -u wordpress -p" + process.env.MYSQL_LOCAL_PWD + " " + process.env.MYSQL_LOCAL_DBNAME + " < " + _path2.default.join(consumerProjectRoot, './deploy/pull.sql'));

        var dbcmd = "";
        dbcmd += "use lwjdesigns;UPDATE wp_options SET option_value = replace(option_value, 'http://localhost:" + process.env.OLD_LOCAL_PORT + "', 'http://localhost:" + process.env.LOCAL_PORT + "') WHERE option_name = 'home' OR option_name = 'siteurl';";
        dbcmd += "UPDATE wp_posts SET guid = replace(guid, 'http://localhost:" + process.env.OLD_LOCAL_PORT + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";
        dbcmd += "UPDATE wp_posts SET post_content = replace(post_content, 'http://localhost:" + process.env.OLD_LOCAL_PORT + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";
        dbcmd += "UPDATE wp_postmeta SET meta_value = replace(meta_value,'http://localhost:" + process.env.OLD_LOCAL_PORT + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";
        var entirecmd = "mysql -u wordpress -p" + process.env.MYSQL_LOCAL_PWD + " -D" + process.env.MYSQL_LOCAL_DBNAME + " -t -e \"" + dbcmd + "\"";
        console.log(entirecmd);
        _shelljs2.default.exec(entirecmd);
        console.log("Updated.");
    } else if (result == "2") {
        /* push database to localhost */
        /* mysql -u wordpress -pdaytonflyers webfocused < push.sql */
        _shelljs2.default.exec("mysql -u wordpress -p" + process.env.MYSQL_LOCAL_PWD + " " + process.env.MYSQL_LOCAL_DBNAME + " < " + _path2.default.join(consumerProjectRoot, './deploy/push.sql'));

        /* replace cloud host with localhost */
        var _dbcmd = "";
        _dbcmd += "UPDATE wp_options SET option_value = replace(option_value, 'http://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "') WHERE option_name = 'home' OR option_name = 'siteurl';";
        _dbcmd += "UPDATE wp_posts SET guid = replace(guid, 'http://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";
        _dbcmd += "UPDATE wp_posts SET post_content = replace(post_content, 'http://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";
        _dbcmd += "UPDATE wp_postmeta SET meta_value = replace(meta_value,'http://" + process.env.DROPLET_HOST + "', 'http://localhost:" + process.env.LOCAL_PORT + "');";

        var _entirecmd = "mysql -u wordpress -p" + process.env.MYSQL_LOCAL_PWD + " -D" + process.env.MYSQL_LOCAL_DBNAME + " -t -e \"" + _dbcmd + "\"";
        console.log(_entirecmd);
        _shelljs2.default.exec(_entirecmd);
        console.log("Updated.");
    } else {
        console.error('Invalid option chosen. Must type `1` or `2`.');
        process.exit(1);
    }
});