"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ssh = require("ssh2");

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('dotenv').config({ path: '../.env' });
var consumerProjectRoot = _path2.default.resolve("./"); // evanston-avenue, for instance

var SSH = function () {
    function SSH() {
        _classCallCheck(this, SSH);

        this.connection = new _ssh.Client();
        this.CONNECTION_PARAMS = {
            host: (process.env.SSH_PREFIX || "") + process.env.DROPLET_HOST,
            port: 22,
            username: process.env.DROPLET_USER,
            password: process.env.DROPLET_PWD,
            privateKey: require('fs').readFileSync(_path2.default.resolve(process.env['HOME'] + '/.ssh/id_rsa'))
        };
        this.CONNECTED_STR = "\nConnected & Ready...";
    }

    _createClass(SSH, [{
        key: "connect",
        value: function connect() {
            var _this = this;

            return new _bluebird2.default(function (resolve, reject) {
                _this.connection.on('ready', function () {
                    console.log(_this.CONNECTED_STR);
                    resolve();
                }).connect(_this.CONNECTION_PARAMS);
            });
        }
    }, {
        key: "close",
        value: function close() {
            var _this2 = this;

            return new _bluebird2.default(function (resolve, reject) {
                _this2.connection.end();
                resolve();
            });
        }

        /* executes ssh command and returns a promise */

    }, {
        key: "execAsync",
        value: function execAsync(cmd) {
            var _this3 = this;

            return new _bluebird2.default(function (resolve, reject) {
                _this3.connection.exec(cmd, function (err, stream) {
                    _this3.sshExecHandler(err, stream, resolve);
                });
            });
        }
    }, {
        key: "cloudpackage",
        value: function cloudpackage() {

            /* mysqldump -u wordpress -p01aefbf3e1f51eb469895a12b6f8caca7e27f8767dcd0def wordpress > pull.sql */

            var cmd = "cd " + process.env.CLOUD_ROOT + " && mysqldump -u wordpress -p" + process.env.MYSQL_CLOUD_PWD + " wordpress > pull.sql || true" + /* pull the database */
            " && zip -FSr pull.zip * -x wp-config.php -x pull.sql"; /* zip file system, excluding wp-config.php */
            return this.execAsync(cmd).bind(this);
        }
    }, {
        key: "download",
        value: function download() {
            var _this4 = this;

            return new _bluebird2.default(function (resolve, reject) {
                _this4.connection.sftp(function (err, sftp) {
                    if (err) throw err;
                    console.log("\nDownloading " + _path2.default.resolve(process.env.CLOUD_ROOT + "/pull.zip..."));
                    sftp.fastGet(_path2.default.resolve(process.env.CLOUD_ROOT + "/pull.zip"), _path2.default.join(consumerProjectRoot, "./deploy/pull.zip"), {}, function (err) {
                        if (err) throw err;
                        console.log("Successfully downloaded to " + _path2.default.join(consumerProjectRoot, "./deploy/pull.zip"));
                        console.log("\nDownloading " + _path2.default.resolve(process.env.CLOUD_ROOT + "/pull.sql..."));
                        sftp.fastGet(_path2.default.resolve(process.env.CLOUD_ROOT + "/pull.sql"), _path2.default.join(consumerProjectRoot, "./deploy/pull.sql"), {}, function (err) {
                            if (err) throw err;
                            console.log("Successfully downloaded to " + _path2.default.join(consumerProjectRoot, "./deploy/pull.sql"));
                            resolve();
                        });
                    });
                });
            });
        }
    }, {
        key: "upload",
        value: function upload() {
            var _this5 = this;

            return new _bluebird2.default(function (resolve, reject) {
                _this5.connection.sftp(function (err, sftp) {
                    if (err) throw err;
                    console.log("\nUploading " + _path2.default.join(consumerProjectRoot, "./deploy/push.zip..."));
                    sftp.fastPut(_path2.default.join(consumerProjectRoot, "./deploy/push.zip"), _path2.default.resolve(process.env.CLOUD_ROOT + "/push.zip"), {}, function (err) {
                        if (err) throw err;
                        console.log("Successfully uploaded to " + _path2.default.resolve(process.env.CLOUD_ROOT + "/push.zip"));
                        console.log("\nUploading " + _path2.default.join(consumerProjectRoot, "./deploy/push.sql..."));
                        sftp.fastPut(_path2.default.join(consumerProjectRoot, "./deploy/push.sql"), _path2.default.resolve(process.env.CLOUD_ROOT + "/push.sql"), {}, function (err) {
                            if (err) throw err;
                            console.log("Successfully uploaded to " + _path2.default.resolve(process.env.CLOUD_ROOT + "/push.sql"));
                            resolve();
                        });
                    });
                });
            });
        }
    }, {
        key: "cloudunpack",
        value: function cloudunpack() {

            /* prepare to replace localhost with cloud host */
            var dbcmd = "";
            dbcmd += "UPDATE wp_options SET option_value = replace(option_value, 'http://localhost:" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "') WHERE option_name = 'home' OR option_name = 'siteurl';";
            dbcmd += "UPDATE wp_posts SET guid = replace(guid, 'http://localhost:" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "');";
            dbcmd += "UPDATE wp_posts SET post_content = replace(post_content, 'http://localhost:" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "');";
            dbcmd += "UPDATE wp_postmeta SET meta_value = replace(meta_value,'http://localhost:" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "');";

            dbcmd += "UPDATE wp_options SET option_value = replace(option_value, 'http://127.0.0.1" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "') WHERE option_name = 'home' OR option_name = 'siteurl';";
            dbcmd += "UPDATE wp_posts SET guid = replace(guid, 'http://127.0.0.1" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "');";
            dbcmd += "UPDATE wp_posts SET post_content = replace(post_content, 'http://127.0.0.1" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "');";
            dbcmd += "UPDATE wp_postmeta SET meta_value = replace(meta_value,'http://127.0.0.1" + process.env.LOCAL_PORT + "', '" + (process.env.DROPLET_PROTOCOL || 'http') + "://" + process.env.DROPLET_HOST + "');";

            var entirecmd = "mysql -u wordpress -p" + process.env.MYSQL_CLOUD_PWD + " -Dwordpress -t -e \"use wordpress;" + dbcmd + "\"";
            var permissionsCmd = "sudo chown -R www-data:www-all /var/www && sudo find /var/www/ -type d -exec chmod 775 {} \\; && sudo find /var/www/ -type f -exec chmod 664 {} \\; && sudo chown -R www-data:www-all /var/log/apache2";

            this.unpackCmd = "cd " + process.env.CLOUD_ROOT + /* change to apache root */
            " && rm -rf main.js main.css" + /* clean out old assets */
            " && unzip -o push.zip || true" + /* extract package */
            " && mysql -u wordpress -p" + process.env.MYSQL_CLOUD_PWD + " wordpress < push.sql || true" + /* restore the database */
            " && " + entirecmd + " && " + permissionsCmd; /* replace localhost with cloud host */
            return this.execAsync(this.unpackCmd).bind(this);
        }
    }, {
        key: "sshExecHandler",
        value: function sshExecHandler(err, stream, resolve) {
            var _this6 = this;

            if (err) throw err;
            stream.on('close', function (code, signal) {
                console.log('Stream :: close :: code: ' + code + ', signal: ' + signal);
                console.log(_this6.unpackCmd);
                resolve();
            }).on('data', function (data) {
                console.log(data.toString());
            }).stderr.on('data', function (data) {
                console.error(data);
            });
        }
    }]);

    return SSH;
}();

/*sftp.readdir(process.env.CLOUD_ROOT, function(err, list) {
 if (err) throw err;
 console.dir(list);
 this.connection.end();
 resolve();
 });*/


exports.default = SSH;